zoukankan      html  css  js  c++  java
  • HDU 5025 Saving Tang Monk

    Problem Description
    《Journey to the West》(also 《Monkey》) is one of the Four Great Classical Novels of Chinese literature. It was written by Wu Cheng'en during the Ming Dynasty. In this novel, Monkey King Sun Wukong, pig Zhu Bajie and Sha Wujing, escorted Tang Monk to India to get sacred Buddhism texts.

    During the journey, Tang Monk was often captured by demons. Most of demons wanted to eat Tang Monk to achieve immortality, but some female demons just wanted to marry him because he was handsome. So, fighting demons and saving Monk Tang is the major job for Sun Wukong to do.

    Once, Tang Monk was captured by the demon White Bones. White Bones lived in a palace and she cuffed Tang Monk in a room. Sun Wukong managed to get into the palace. But to rescue Tang Monk, Sun Wukong might need to get some keys and kill some snakes in his way.

    The palace can be described as a matrix of characters. Each character stands for a room. In the matrix, 'K' represents the original position of Sun Wukong, 'T' represents the location of Tang Monk and 'S' stands for a room with a snake in it. Please note that there are only one 'K' and one 'T', and at most five snakes in the palace. And, '.' means a clear room as well '#' means a deadly room which Sun Wukong couldn't get in.

    There may be some keys of different kinds scattered in the rooms, but there is at most one key in one room. There are at most 9 kinds of keys. A room with a key in it is represented by a digit(from '1' to '9'). For example, '1' means a room with a first kind key, '2' means a room with a second kind key, '3' means a room with a third kind key... etc. To save Tang Monk, Sun Wukong must get ALL kinds of keys(in other words, at least one key for each kind).

    For each step, Sun Wukong could move to the adjacent rooms(except deadly rooms) in 4 directions(north, west, south and east), and each step took him one minute. If he entered a room in which a living snake stayed, he must kill the snake. Killing a snake also took one minute. If Sun Wukong entered a room where there is a key of kind N, Sun would get that key if and only if he had already got keys of kind 1,kind 2 ... and kind N-1. In other words, Sun Wukong must get a key of kind N before he could get a key of kind N+1 (N>=1). If Sun Wukong got all keys he needed and entered the room in which Tang Monk was cuffed, the rescue mission is completed. If Sun Wukong didn't get enough keys, he still could pass through Tang Monk's room. Since Sun Wukong was a impatient monkey, he wanted to save Tang Monk as quickly as possible. Please figure out the minimum time Sun Wukong needed to rescue Tang Monk.
     
    Input
    There are several test cases.

    For each case, the first line includes two integers N and M(0 < N <= 100, 0<=M<=9), meaning that the palace is a N×N matrix and Sun Wukong needed M kinds of keys(kind 1, kind 2, ... kind M).

    Then the N × N matrix follows.

    The input ends with N = 0 and M = 0.
     
    Output
    For each test case, print the minimum time (in minutes) Sun Wukong needed to save Tang Monk. If it's impossible for Sun Wukong to complete the mission, print "impossible"(no quotes).
     
    Sample Input
    3 1
    K.S
    ##1
    1#T
    3 1
    K#T
    .S#
    1#.
    3 2
    K#T
    .S.
    21.
    0 0
     
    Sample Output
    5
    impossible
    8
     
    题意
    孙悟空要去救师傅,K代表起点,T为唐僧位置,S代表有蛇的房间(不会超过五条蛇),#为剧毒房间,无法进入 带数字的房间为有钥匙的房间(不超过9个),孙悟空必须先拿到第一个钥匙,再拿第二个....最后拿到第m个钥匙,才能解救唐僧 没有拿到第m个钥匙的时候可以路过但是不能解救唐僧,路过有蛇的房间的时候需要花一分钟杀蛇,杀掉之后再经过时就不用再花时间杀蛇,但是每经过一个房间需要花费一分钟,求就出唐僧最短的时间。
     
    分析
    由于杀蛇需要花费时间,所以不能是找到了唐僧就是最短时间,必须将所有的可能性取最小值,这是这道题和不同的bfs最大的不同,另外,需要一个五位二进制数来存目前杀蛇的情况(这样一个数就可以概括全部的五条蛇,当然我认为也可以用一个数组来存,但是太费空间)
     
    下面是代码,直接看代码更容易理解
     1 #include <cstdio>
     2 #include <cstring>
     3 #include <algorithm>
     4 #include <iostream>
     5 #include <queue>
     6 using namespace std;
     7 #define N 105
     8 #define INF 0x3f3f3f3f
     9 
    10 struct node
    11 {
    12     int x, y, t, key, snake;
    13     node() {}
    14     node(int x, int y, int t, int key, int snake) : x(x), y(y), t(t), key(key), snake(snake) {}
    15 };
    16 bool vis[N][N][10][40];
    17 int n, m, sx, sy, ex, ey;
    18 int dx[] = {1, -1, 0, 0}, dy[] = {0, 0, 1, -1};
    19 char maze[N][N];
    20 
    21 bool check(int x, int y)
    22 {
    23     if(0<=x&&x<n&&0<=y&&y<n&&maze[x][y]!='#') return true;  //判断能不能走
    24     return false;
    25 }
    26 
    27 void bfs()
    28 {
    29     int ans = INF;
    30     memset(vis, 0, sizeof(vis));
    31     queue<node> que;
    32     while(!que.empty()) que.pop();     //清空队列 因为有多个测试
    33     que.push(node(sx, sy, 0, 0, 0));
    34     while(!que.empty()) {
    35         node top = que.front(); que.pop();
    36         int x = top.x, y = top.y, key = top.key, snake = top.snake, t = top.t;
    37         if(key == m && maze[x][y] == 'T') {
    38             ans = min(ans, t);      //取最短时间
    39         }
    40         if(vis[x][y][key][snake] != 0) continue;   //判断当前“状态”有没有访问过,注意是“状态”,不是房间,房间是可以重复访问的
    41         vis[x][y][key][snake] = 1;
    42         for(int i = 0; i < 4; i++) {
    43             int nx = x + dx[i], ny = y + dy[i];
    44             if(!check(nx, ny)) continue;
    45             node now = top;
    46             if('A' <= maze[nx][ny] && maze[nx][ny] <= 'G') {
    47                 //只有五条蛇,不能写 <= 'Z'
    48                 int s = maze[nx][ny] - 'A';
    49                 if((1<<s) & now.snake) ; //如果蛇被打了
    50                 else {
    51                     now.snake |= (1<<s); //没被打,时间加1 记录打蛇情况
    52                     now.t++;
    53                 }
    54             } else if(maze[nx][ny] - '0' == now
    .key + 1) {
    55                 now.key++;
    56             }
    57             now.t++;
    58             que.push(node(nx, ny, now.t, now.key, now.snake));
    59         }
    60     }
    61     if(ans != INF) printf("%d\n", ans);
    62     else printf("impossible\n");
    63 }
    64 
    65 int main()
    66 {
    67     while(~scanf("%d%d", &n, &m), n+m) {
    68         int cnt = 0;
    69         for(int i = 0; i < n; i++) {
    70             scanf("%s", maze[i]);
    71         }
    72         for(int i = 0; i < n; i++) {
    73             for(int j = 0; j < n; j++) {
    74                 if(maze[i][j] == 'K') sx = i, sy = j;
    75                 if(maze[i][j] == 'S') {maze[i][j] = cnt+'A'; cnt++;}
    76             }
    77         }
    78         bfs();
    79     }
    80     return 0;
    81 }
  • 相关阅读:
    PCA 最大方差理论的直观解释
    支持向量机综述
    sklearn 的 PolynomialFeatures 的用法
    (转载)FM 算法
    (转载)Kaggle_Titanic生存预测 -- 详细流程吐血梳理
    (转载)Scikit-learn使用总结
    m96-97 lsc nc赛
    CSP-S 94 (sb lsc gc赛)
    CSP-S 95 (sb lsc yy赛)
    小反思
  • 原文地址:https://www.cnblogs.com/dyhaohaoxuexi/p/10629672.html
Copyright © 2011-2022 走看看